unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Image1: TImage;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Memo1: TMemo;
    Fixed_Field: TStringGrid;
    fall_field: TStringGrid;
    fall_type: TEdit;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    Beenden1: TMenuItem;
    Debuganzeige1: TMenuItem;
    NeuesSpiel1: TMenuItem;
    Pause1: TMenuItem;
    Label1: TLabel;
    E_Pts: TEdit;
    Label2: TLabel;
    E_lvl: TEdit;
    BT: TButton;
    next_field: TStringGrid;
    next_type: TEdit;
    nextimage: TImage;
    Label3: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Memo1Change(Sender: TObject);
    procedure NeuesSpiel1Click(Sender: TObject);
    procedure Pause1Click(Sender: TObject);
    procedure Debuganzeige1Click(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure E_PtsChange(Sender: TObject);
    procedure BTClick(Sender: TObject);
    procedure next_typeChange(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }

    function CheckFixing:boolean;
    function CheckNewPosition(i,x,y:Integer):boolean;
    function CheckFirstRow:boolean;

    procedure CheckRows;

    procedure Clear_Field;
    procedure Clear_Image;

    procedure Create_Random;

    procedure Visualize;
    procedure Draw_Rectangle(x1,y1:Integer);

    procedure Move_Down;
    procedure Move_Left;
    procedure Move_Right;

    procedure Fix;

    procedure GameOver;

    procedure Rotate;
  end;

var
  Form1: TForm1;
  instance_run:boolean=false;
  einheit:Integer=20;

implementation

{$R *.DFM}

procedure TForm1.Button6Click(Sender: TObject);
begin
  if instance_run <> true then exit;

  Move_Down;

  Visualize;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  CheckRows;

  if CheckFirstRow then GameOver;

  if instance_run <> true then exit;

  CheckFixing;

  Move_Down;

  Visualize;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Canvas.Brush.Color:=clWhite;
  Image1.Canvas.Rectangle(0,0,Image1.Width,Image1.Height);
  Image1.Canvas.Brush.Color:=clBlack;
  nextimage.Canvas.Brush.Color:=clWhite;
  nextimage.Canvas.Rectangle(0,0,nextimage.Width,nextimage.Height);
  nextimage.Canvas.Brush.Color:=clBlack;
  ActiveControl:=Memo1;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if instance_run <> true then exit;

  Move_Right;

  Visualize;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if instance_run <> true then exit;

  Move_Left;

  Visualize;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  if instance_run <> true then exit;

  Rotate;

  Visualize;
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
  Memo1.Text:='Ins Feld klicken und ber Pfeiltasten steuern';
end;

procedure TForm1.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If Key = 37 then Button3Click(Memo1);
  If Key = 38 then Button5Click(Memo1);
  If Key = 39 then Button4Click(Memo1);
  If Key = 40 then Button6Click(Memo1);
end;

procedure TForm1.NeuesSpiel1Click(Sender: TObject);
begin
  E_pts.Text:='0';
  E_lvl.Text:='0';
  Timer1.Interval:=1000;
  
  Clear_Field;

  instance_run:=true;

  Timer1.Enabled:=true;

  Create_Random;

  Move_Down;

  Visualize;
end;

procedure TForm1.Pause1Click(Sender: TObject);
begin
  if instance_run then
    begin
      instance_run:=false;
      Timer1.Enabled:=false;
    end
  else
    begin
      instance_run:=true;
      Timer1.Enabled:=true;
    end;
end;

procedure TForm1.Debuganzeige1Click(Sender: TObject);
begin
  if Fixed_Field.Visible then
    Fixed_Field.Visible:=false
  else Fixed_Field.Visible:=true;

  if fall_Field.Visible then
    fall_Field.Visible:=false
  else fall_Field.Visible:=true;

  if next_Field.Visible then
    next_Field.Visible:=false
  else next_Field.Visible:=true;

  if fall_type.Visible then
    fall_type.Visible:=false
  else fall_type.Visible:=true;

  if next_type.Visible then
    next_type.Visible:=false
  else next_type.Visible:=true;

  if BT.Visible then
    BT.Visible:=false
  else BT.Visible:=true;
end;

procedure TForm1.Beenden1Click(Sender: TObject);
begin
  close;
end;


//EIGENE Procedures


function TForm1.CheckFixing:boolean;
var i:Integer;
begin
  Result:=true;

  for i := 0 to 3 do
    begin
      if StrToInt(fall_field.Cells[1,i])=14*einheit then
        Fix;
      if Fixed_Field.Cells[StrToInt(FloatToStr( StrToInt(fall_field.Cells[0,i])/einheit)),StrToInt(FloatToStr( StrToInt(fall_field.Cells[1,i])/einheit +1 ))]='1' then
        Fix;
    end;
end;

function TForm1.CheckNewPosition(i,x,y:Integer):boolean;
begin
  Result:=true;
  if (StrToInt(fall_field.Cells[0,i])+x*einheit) < 0 then
    Result:=false
  else if (StrToInt(fall_field.Cells[0,i])+x*einheit) > 9*einheit then
    Result:=false
  else if (StrToInt(fall_field.Cells[1,i])+y*einheit) < 0 then
    Result:=false
  else if (StrToInt(fall_field.Cells[1,i])+y*einheit) > 14*einheit then
    Result:=false

  else if Fixed_Field.Cells[StrToInt(FloatToStr( StrToInt(fall_field.Cells[0,i])/einheit +x )),StrToInt(FloatToStr( StrToInt(fall_field.Cells[1,i])/einheit +y ))]='1' then
    Result:=false;
end;

function TForm1.CheckFirstRow:boolean;
var i:INteger;
begin
  Result:=false;
  for i:=0 to 9 do
    if Fixed_Field.Cells[i,0]='1' then
      Result:=true;
end;

procedure TForm1.CheckRows;
var i,j,k:INteger;
row:boolean;
begin
  for i:=0 to 14 do
    begin
      row:=true;
      for j:=0 to 9 do
        if Fixed_Field.Cells[j,i]='0' then
          row:=false;
      if row then
        begin
          E_pts.Text:=IntToStr(StrToInt(E_pts.Text)+1);
          for k:=i downto 1 do
            Fixed_Field.Rows[k]:=Fixed_Field.Rows[(k-1)];
        end;
    end;
end;

procedure TForm1.Clear_Image;
begin
  Image1.Canvas.Brush.Color:=clWhite;
  Image1.Canvas.Rectangle(0,0,Image1.Width,Image1.Height);
  Image1.Canvas.Brush.Color:=clBlack;
end;

procedure TForm1.Clear_Field;
var i,j:Integer;
begin

  Clear_Image;

  for i:=0 to 9 do
    for j:=0 to 14 do
      Fixed_Field.Cells[i,j]:='0';
  for i:=0 to 1 do
    for j:=0 to 3 do
      next_field.Cells[i,j]:='';
end;

procedure TForm1.Create_Random;
var z,i,j:Integer;
begin
  Randomize;

  //Wenn next field gefllt
  if next_field.Cells[0,0]<>'' then
    begin
      //next auslesen
      for i:=0 to 1 do
        for j:=0 to 3 do
          fall_field.Cells[i,j]:=next_field.Cells[i,j];
      fall_type.Text:=next_type.Text;
    end
  else //wenn next leer (erste runde) dann erstelle random
    begin
      z:=Random(6);
      case z of
        0: begin
             fall_field.Cells[0,0]:=IntToStr(4*einheit); fall_field.Cells[1,0]:=IntToStr(0);
             fall_field.Cells[0,1]:=IntToStr(5*einheit); fall_field.Cells[1,1]:=IntToStr(0);
             fall_field.Cells[0,2]:=IntToStr(4*einheit); fall_field.Cells[1,2]:=IntToStr(einheit);
             fall_field.Cells[0,3]:=IntToStr(5*einheit); fall_field.Cells[1,3]:=IntToStr(einheit);
             fall_type.Text:='0';
           end;
        1: begin
             fall_field.Cells[0,0]:=IntToStr(3*einheit); fall_field.Cells[1,0]:=IntToStr(einheit);
             fall_field.Cells[0,1]:=IntToStr(4*einheit); fall_field.Cells[1,1]:=IntToStr(einheit);
             fall_field.Cells[0,2]:=IntToStr(4*einheit); fall_field.Cells[1,2]:=IntToStr(0);
             fall_field.Cells[0,3]:=IntToStr(5*einheit); fall_field.Cells[1,3]:=IntToStr(0);
             fall_type.Text:='1';
           end;
        2: begin
             fall_field.Cells[0,0]:=IntToStr(3*einheit); fall_field.Cells[1,0]:=IntToStr(0);
             fall_field.Cells[0,1]:=IntToStr(4*einheit); fall_field.Cells[1,1]:=IntToStr(0);
             fall_field.Cells[0,2]:=IntToStr(4*einheit); fall_field.Cells[1,2]:=IntToStr(einheit);
             fall_field.Cells[0,3]:=IntToStr(5*einheit); fall_field.Cells[1,3]:=IntToStr(einheit);
             fall_type.Text:='2';
           end;
        3: begin
             fall_field.Cells[0,0]:=IntToStr(3*einheit); fall_field.Cells[1,0]:=IntToStr(0);
             fall_field.Cells[0,1]:=IntToStr(4*einheit); fall_field.Cells[1,1]:=IntToStr(0);
             fall_field.Cells[0,2]:=IntToStr(5*einheit); fall_field.Cells[1,2]:=IntToStr(0);
             fall_field.Cells[0,3]:=IntToStr(6*einheit); fall_field.Cells[1,3]:=IntToStr(0);
             fall_type.Text:='3';
           end;
        4: begin
             fall_field.Cells[0,0]:=IntToStr(4*einheit); fall_field.Cells[1,0]:=IntToStr(0);
             fall_field.Cells[0,1]:=IntToStr(4*einheit); fall_field.Cells[1,1]:=IntToStr(einheit);
             fall_field.Cells[0,2]:=IntToStr(4*einheit); fall_field.Cells[1,2]:=IntToStr(2*einheit);
             fall_field.Cells[0,3]:=IntToStr(5*einheit); fall_field.Cells[1,3]:=IntToStr(2*einheit);
             fall_type.Text:='4';
           end;
        5: begin
             fall_field.Cells[0,0]:=IntToStr(4*einheit); fall_field.Cells[1,0]:=IntToStr(2*einheit);
             fall_field.Cells[0,1]:=IntToStr(5*einheit); fall_field.Cells[1,1]:=IntToStr(2*einheit);
             fall_field.Cells[0,2]:=IntToStr(5*einheit); fall_field.Cells[1,2]:=IntToStr(einheit);
             fall_field.Cells[0,3]:=IntToStr(5*einheit); fall_field.Cells[1,3]:=IntToStr(0);
             fall_type.Text:='5';
           end;
      end;
    end;

  //neues next
  z:=Random(6);
  case z of
    0: begin
         next_field.Cells[0,0]:=IntToStr(4*einheit); next_field.Cells[1,0]:=IntToStr(0);
         next_field.Cells[0,1]:=IntToStr(5*einheit); next_field.Cells[1,1]:=IntToStr(0);
         next_field.Cells[0,2]:=IntToStr(4*einheit); next_field.Cells[1,2]:=IntToStr(einheit);
         next_field.Cells[0,3]:=IntToStr(5*einheit); next_field.Cells[1,3]:=IntToStr(einheit);
         next_type.Text:='0';
       end;
    1: begin
         next_field.Cells[0,0]:=IntToStr(3*einheit); next_field.Cells[1,0]:=IntToStr(einheit);
         next_field.Cells[0,1]:=IntToStr(4*einheit); next_field.Cells[1,1]:=IntToStr(einheit);
         next_field.Cells[0,2]:=IntToStr(4*einheit); next_field.Cells[1,2]:=IntToStr(0);
         next_field.Cells[0,3]:=IntToStr(5*einheit); next_field.Cells[1,3]:=IntToStr(0);
         next_type.Text:='1';
       end;
    2: begin
         next_field.Cells[0,0]:=IntToStr(3*einheit); next_field.Cells[1,0]:=IntToStr(0);
         next_field.Cells[0,1]:=IntToStr(4*einheit); next_field.Cells[1,1]:=IntToStr(0);
         next_field.Cells[0,2]:=IntToStr(4*einheit); next_field.Cells[1,2]:=IntToStr(einheit);
         next_field.Cells[0,3]:=IntToStr(5*einheit); next_field.Cells[1,3]:=IntToStr(einheit);
         next_type.Text:='2';
       end;
    3: begin
         next_field.Cells[0,0]:=IntToStr(3*einheit); next_field.Cells[1,0]:=IntToStr(0);
         next_field.Cells[0,1]:=IntToStr(4*einheit); next_field.Cells[1,1]:=IntToStr(0);
         next_field.Cells[0,2]:=IntToStr(5*einheit); next_field.Cells[1,2]:=IntToStr(0);
         next_field.Cells[0,3]:=IntToStr(6*einheit); next_field.Cells[1,3]:=IntToStr(0);
         next_type.Text:='3';
       end;
    4: begin
         next_field.Cells[0,0]:=IntToStr(4*einheit); next_field.Cells[1,0]:=IntToStr(0);
         next_field.Cells[0,1]:=IntToStr(4*einheit); next_field.Cells[1,1]:=IntToStr(einheit);
         next_field.Cells[0,2]:=IntToStr(4*einheit); next_field.Cells[1,2]:=IntToStr(2*einheit);
         next_field.Cells[0,3]:=IntToStr(5*einheit); next_field.Cells[1,3]:=IntToStr(2*einheit);
         next_type.Text:='4';
       end;
    5: begin
         next_field.Cells[0,0]:=IntToStr(4*einheit); next_field.Cells[1,0]:=IntToStr(2*einheit);
         next_field.Cells[0,1]:=IntToStr(5*einheit); next_field.Cells[1,1]:=IntToStr(2*einheit);
         next_field.Cells[0,2]:=IntToStr(5*einheit); next_field.Cells[1,2]:=IntToStr(einheit);
         next_field.Cells[0,3]:=IntToStr(5*einheit); next_field.Cells[1,3]:=IntToStr(0);
         next_type.Text:='5';
       end;
  end;

end;

procedure TForm1.Visualize;
var i,j:Integer;
begin
  Clear_Image;

  for i:=0 to 3 do
    Draw_Rectangle(StrToInt(fall_field.Cells[0,i]),StrToInt(fall_field.Cells[1,i]));

  for i:=0 to 9 do
    for j:=0 to 14 do
      if Fixed_Field.Cells[i,j]='1' then
        Draw_Rectangle(i*einheit,j*einheit);
end;

procedure TForm1.Draw_Rectangle(x1,y1:Integer);
begin
  Image1.Canvas.FillRect(Rect(x1,y1,(x1+einheit),(y1+einheit)));
end;


procedure TForm1.Move_Down;
var i:INteger;
begin
  for i:= 0 to 3 do
    if CheckNewPosition(i,0,1) <> true then exit;

  for i := 0 to 3 do
    fall_field.Cells[1,i]:=IntToStr(StrToInt(fall_field.Cells[1,i])+einheit);
end;

procedure TForm1.Move_Right;
var i:Integer;
begin
  for i:= 0 to 3 do
    if CheckNewPosition(i,1,0) <> true then exit;

  for i := 0 to 3 do
    fall_field.Cells[0,i]:=IntToStr(StrToInt(fall_field.Cells[0,i])+einheit);
end;

procedure TForm1.Move_Left;
var i:INteger;
begin
  for i:= 0 to 3 do
    if CheckNewPosition(i,-1,0) <> true then exit;

  for i := 0 to 3 do
    fall_field.Cells[0,i]:=IntToStr(StrToInt(fall_field.Cells[0,i])-einheit);
end;

procedure TForm1.Fix;
var i:Integer;
begin
  for i:=0 to 3 do
    Fixed_Field.Cells[StrToInt(FloatToStr(StrToInt(fall_field.Cells[0,i])/einheit)),StrToInt(FloatToStr(StrToInt(fall_field.Cells[1,i])/einheit))]:='1';
  Create_Random;
end;

procedure TForm1.GameOver;
begin
  instance_run:=false;
  Timer1.Enabled:=false;

  ShowMessage('Game OVER');
end;

procedure TForm1.Rotate;
begin
  case StrToInt(fall_type.Text) of
    1: begin
         if CheckNewPosition(0,2,1) <> true then exit;
         if CheckNewPosition(1,1,0) <> true then exit;
         if CheckNewPosition(2,0,1) <> true then exit;
         if CheckNewPosition(3,-1,0) <> true then exit;
         fall_field.Cells[0,0]:=IntToStr(StrToInt(fall_field.Cells[0,0])+2*einheit);
         fall_field.Cells[1,0]:=IntToStr(StrToInt(fall_field.Cells[1,0])+einheit);
         fall_field.Cells[0,1]:=IntToStr(StrToInt(fall_field.Cells[0,1])+einheit);
         fall_field.Cells[1,1]:=IntToStr(StrToInt(fall_field.Cells[1,1]));
         fall_field.Cells[0,2]:=IntToStr(StrToInt(fall_field.Cells[0,2]));
         fall_field.Cells[1,2]:=IntToStr(StrToInt(fall_field.Cells[1,2])+einheit);
         fall_field.Cells[0,3]:=IntToStr(StrToInt(fall_field.Cells[0,3])-einheit);
         fall_field.Cells[1,3]:=IntToStr(StrToInt(fall_field.Cells[1,3]));
         fall_type.Text:='11';
       end;
    11: begin
         if CheckNewPosition(0,-2,-1) <> true then exit;
         if CheckNewPosition(1,-1,0) <> true then exit;
         if CheckNewPosition(2,0,-1) <> true then exit;
         if CheckNewPosition(3,1,0) <> true then exit;
         fall_field.Cells[0,0]:=IntToStr(StrToInt(fall_field.Cells[0,0])-2*einheit);
         fall_field.Cells[1,0]:=IntToStr(StrToInt(fall_field.Cells[1,0])-einheit);
         fall_field.Cells[0,1]:=IntToStr(StrToInt(fall_field.Cells[0,1])-einheit);
         fall_field.Cells[1,1]:=IntToStr(StrToInt(fall_field.Cells[1,1]));
         fall_field.Cells[0,2]:=IntToStr(StrToInt(fall_field.Cells[0,2]));
         fall_field.Cells[1,2]:=IntToStr(StrToInt(fall_field.Cells[1,2])-einheit);
         fall_field.Cells[0,3]:=IntToStr(StrToInt(fall_field.Cells[0,3])+einheit);
         fall_field.Cells[1,3]:=IntToStr(StrToInt(fall_field.Cells[1,3]));
         fall_type.Text:='1';
       end;
    2: begin
         if CheckNewPosition(0,2,0) <> true then exit;
         if CheckNewPosition(1,1,1) <> true then exit;
         if CheckNewPosition(2,0,0) <> true then exit;
         if CheckNewPosition(3,-1,1) <> true then exit;
         fall_field.Cells[0,0]:=IntToStr(StrToInt(fall_field.Cells[0,0])+2*einheit);
         fall_field.Cells[1,0]:=IntToStr(StrToInt(fall_field.Cells[1,0]));
         fall_field.Cells[0,1]:=IntToStr(StrToInt(fall_field.Cells[0,1])+einheit);
         fall_field.Cells[1,1]:=IntToStr(StrToInt(fall_field.Cells[1,1])+einheit);
         fall_field.Cells[0,2]:=IntToStr(StrToInt(fall_field.Cells[0,2]));
         fall_field.Cells[1,2]:=IntToStr(StrToInt(fall_field.Cells[1,2]));
         fall_field.Cells[0,3]:=IntToStr(StrToInt(fall_field.Cells[0,3])-einheit);
         fall_field.Cells[1,3]:=IntToStr(StrToInt(fall_field.Cells[1,3])+einheit);
         fall_type.Text:='21';
       end;
    21: begin
         if CheckNewPosition(0,-2,0) <> true then exit;
         if CheckNewPosition(1,-1,-1) <> true then exit;
         if CheckNewPosition(2,0,0) <> true then exit;
         if CheckNewPosition(3,1,-1) <> true then exit;
         fall_field.Cells[0,0]:=IntToStr(StrToInt(fall_field.Cells[0,0])-2*einheit);
         fall_field.Cells[1,0]:=IntToStr(StrToInt(fall_field.Cells[1,0]));
         fall_field.Cells[0,1]:=IntToStr(StrToInt(fall_field.Cells[0,1])-einheit);
         fall_field.Cells[1,1]:=IntToStr(StrToInt(fall_field.Cells[1,1])-einheit);
         fall_field.Cells[0,2]:=IntToStr(StrToInt(fall_field.Cells[0,2]));
         fall_field.Cells[1,2]:=IntToStr(StrToInt(fall_field.Cells[1,2]));
         fall_field.Cells[0,3]:=IntToStr(StrToInt(fall_field.Cells[0,3])+einheit);
         fall_field.Cells[1,3]:=IntToStr(StrToInt(fall_field.Cells[1,3])-einheit);
         fall_type.Text:='2';
       end;
    3: begin
         if CheckNewPosition(0,1,2) <> true then exit;
         if CheckNewPosition(1,0,1) <> true then exit;
         if CheckNewPosition(2,-1,0) <> true then exit;
         if CheckNewPosition(3,-2,-1) <> true then exit;
         fall_field.Cells[0,0]:=IntToStr(StrToInt(fall_field.Cells[0,0])+einheit);
         fall_field.Cells[1,0]:=IntToStr(StrToInt(fall_field.Cells[1,0])+2*einheit);
         fall_field.Cells[0,1]:=IntToStr(StrToInt(fall_field.Cells[0,1]));
         fall_field.Cells[1,1]:=IntToStr(StrToInt(fall_field.Cells[1,1])+einheit);
         fall_field.Cells[0,2]:=IntToStr(StrToInt(fall_field.Cells[0,2])-einheit);
         fall_field.Cells[1,2]:=IntToStr(StrToInt(fall_field.Cells[1,2]));
         fall_field.Cells[0,3]:=IntToStr(StrToInt(fall_field.Cells[0,3])-2*einheit);
         fall_field.Cells[1,3]:=IntToStr(StrToInt(fall_field.Cells[1,3])-einheit);
         fall_type.Text:='31';
        end;
    31: begin
         if CheckNewPosition(0,-1,-2) <> true then exit;
         if CheckNewPosition(1,0,-1) <> true then exit;
         if CheckNewPosition(2,1,0) <> true then exit;
         if CheckNewPosition(3,2,1) <> true then exit;
         fall_field.Cells[0,0]:=IntToStr(StrToInt(fall_field.Cells[0,0])-einheit);
         fall_field.Cells[1,0]:=IntToStr(StrToInt(fall_field.Cells[1,0])-2*einheit);
         fall_field.Cells[0,1]:=IntToStr(StrToInt(fall_field.Cells[0,1]));
         fall_field.Cells[1,1]:=IntToStr(StrToInt(fall_field.Cells[1,1])-einheit);
         fall_field.Cells[0,2]:=IntToStr(StrToInt(fall_field.Cells[0,2])+einheit);
         fall_field.Cells[1,2]:=IntToStr(StrToInt(fall_field.Cells[1,2]));
         fall_field.Cells[0,3]:=IntToStr(StrToInt(fall_field.Cells[0,3])+2*einheit);
         fall_field.Cells[1,3]:=IntToStr(StrToInt(fall_field.Cells[1,3])+einheit);
         fall_type.Text:='3';
       end;
    4: begin
         if CheckNewPosition(0,-1,2) <> true then exit;
         if CheckNewPosition(1,0,1) <> true then exit;
         if CheckNewPosition(2,1,0) <> true then exit;
         if CheckNewPosition(3,0,-1) <> true then exit;
         fall_field.Cells[0,0]:=IntToStr(StrToInt(fall_field.Cells[0,0])-einheit);
         fall_field.Cells[1,0]:=IntToStr(StrToInt(fall_field.Cells[1,0])+2*einheit);
         fall_field.Cells[0,1]:=IntToStr(StrToInt(fall_field.Cells[0,1]));
         fall_field.Cells[1,1]:=IntToStr(StrToInt(fall_field.Cells[1,1])+einheit);
         fall_field.Cells[0,2]:=IntToStr(StrToInt(fall_field.Cells[0,2])+einheit);
         fall_field.Cells[1,2]:=IntToStr(StrToInt(fall_field.Cells[1,2]));
         fall_field.Cells[0,3]:=IntToStr(StrToInt(fall_field.Cells[0,3]));
         fall_field.Cells[1,3]:=IntToStr(StrToInt(fall_field.Cells[1,3])-einheit);
         fall_type.Text:='41';
        end;
    41: begin
         if CheckNewPosition(0,2,1) <> true then exit;
         if CheckNewPosition(1,1,0) <> true then exit;
         if CheckNewPosition(2,0,-1) <> true then exit;
         if CheckNewPosition(3,-1,0) <> true then exit;
         fall_field.Cells[0,0]:=IntToStr(StrToInt(fall_field.Cells[0,0])+2*einheit);
         fall_field.Cells[1,0]:=IntToStr(StrToInt(fall_field.Cells[1,0])+einheit);
         fall_field.Cells[0,1]:=IntToStr(StrToInt(fall_field.Cells[0,1])+einheit);
         fall_field.Cells[1,1]:=IntToStr(StrToInt(fall_field.Cells[1,1]));
         fall_field.Cells[0,2]:=IntToStr(StrToInt(fall_field.Cells[0,2]));
         fall_field.Cells[1,2]:=IntToStr(StrToInt(fall_field.Cells[1,2])-einheit);
         fall_field.Cells[0,3]:=IntToStr(StrToInt(fall_field.Cells[0,3])-einheit);
         fall_field.Cells[1,3]:=IntToStr(StrToInt(fall_field.Cells[1,3]));
         fall_type.Text:='42';
       end;
    42: begin
         if CheckNewPosition(0,1,-2) <> true then exit;
         if CheckNewPosition(1,0,-1) <> true then exit;
         if CheckNewPosition(2,-1,0) <> true then exit;
         if CheckNewPosition(3,0,1) <> true then exit;
         fall_field.Cells[0,0]:=IntToStr(StrToInt(fall_field.Cells[0,0])+einheit);
         fall_field.Cells[1,0]:=IntToStr(StrToInt(fall_field.Cells[1,0])-2*einheit);
         fall_field.Cells[0,1]:=IntToStr(StrToInt(fall_field.Cells[0,1]));
         fall_field.Cells[1,1]:=IntToStr(StrToInt(fall_field.Cells[1,1])-einheit);
         fall_field.Cells[0,2]:=IntToStr(StrToInt(fall_field.Cells[0,2])-einheit);
         fall_field.Cells[1,2]:=IntToStr(StrToInt(fall_field.Cells[1,2]));
         fall_field.Cells[0,3]:=IntToStr(StrToInt(fall_field.Cells[0,3]));
         fall_field.Cells[1,3]:=IntToStr(StrToInt(fall_field.Cells[1,3])+einheit);
         fall_type.Text:='43';
        end;
    43: begin
         if CheckNewPosition(0,-2,-1) <> true then exit;
         if CheckNewPosition(1,-1,0) <> true then exit;
         if CheckNewPosition(2,0,1) <> true then exit;
         if CheckNewPosition(3,1,0) <> true then exit;
         fall_field.Cells[0,0]:=IntToStr(StrToInt(fall_field.Cells[0,0])-2*einheit);
         fall_field.Cells[1,0]:=IntToStr(StrToInt(fall_field.Cells[1,0])-einheit);
         fall_field.Cells[0,1]:=IntToStr(StrToInt(fall_field.Cells[0,1])-einheit);
         fall_field.Cells[1,1]:=IntToStr(StrToInt(fall_field.Cells[1,1]));
         fall_field.Cells[0,2]:=IntToStr(StrToInt(fall_field.Cells[0,2]));
         fall_field.Cells[1,2]:=IntToStr(StrToInt(fall_field.Cells[1,2])+einheit);
         fall_field.Cells[0,3]:=IntToStr(StrToInt(fall_field.Cells[0,3])+einheit);
         fall_field.Cells[1,3]:=IntToStr(StrToInt(fall_field.Cells[1,3]));
         fall_type.Text:='4';
       end;
    5: begin
         if CheckNewPosition(0,1,0) <> true then exit;
         if CheckNewPosition(1,0,-1) <> true then exit;
         if CheckNewPosition(2,-1,0) <> true then exit;
         if CheckNewPosition(3,-2,1) <> true then exit;
         fall_field.Cells[0,0]:=IntToStr(StrToInt(fall_field.Cells[0,0])+einheit);
         fall_field.Cells[1,0]:=IntToStr(StrToInt(fall_field.Cells[1,0]));
         fall_field.Cells[0,1]:=IntToStr(StrToInt(fall_field.Cells[0,1]));
         fall_field.Cells[1,1]:=IntToStr(StrToInt(fall_field.Cells[1,1])-einheit);
         fall_field.Cells[0,2]:=IntToStr(StrToInt(fall_field.Cells[0,2])-einheit);
         fall_field.Cells[1,2]:=IntToStr(StrToInt(fall_field.Cells[1,2]));
         fall_field.Cells[0,3]:=IntToStr(StrToInt(fall_field.Cells[0,3])-2*einheit);
         fall_field.Cells[1,3]:=IntToStr(StrToInt(fall_field.Cells[1,3])+einheit);
         fall_type.Text:='51';
        end;
    51: begin
         if CheckNewPosition(0,0,-1) <> true then exit;
         if CheckNewPosition(1,-1,0) <> true then exit;
         if CheckNewPosition(2,0,1) <> true then exit;
         if CheckNewPosition(3,1,2) <> true then exit;
         fall_field.Cells[0,0]:=IntToStr(StrToInt(fall_field.Cells[0,0]));
         fall_field.Cells[1,0]:=IntToStr(StrToInt(fall_field.Cells[1,0])-einheit);
         fall_field.Cells[0,1]:=IntToStr(StrToInt(fall_field.Cells[0,1])-einheit);
         fall_field.Cells[1,1]:=IntToStr(StrToInt(fall_field.Cells[1,1]));
         fall_field.Cells[0,2]:=IntToStr(StrToInt(fall_field.Cells[0,2]));
         fall_field.Cells[1,2]:=IntToStr(StrToInt(fall_field.Cells[1,2])+einheit);
         fall_field.Cells[0,3]:=IntToStr(StrToInt(fall_field.Cells[0,3])+einheit);
         fall_field.Cells[1,3]:=IntToStr(StrToInt(fall_field.Cells[1,3])+2*einheit);
         fall_type.Text:='52';
       end;
    52: begin
         if CheckNewPosition(0,-1,0) <> true then exit;
         if CheckNewPosition(1,0,1) <> true then exit;
         if CheckNewPosition(2,1,0) <> true then exit;
         if CheckNewPosition(3,2,-1) <> true then exit;
         fall_field.Cells[0,0]:=IntToStr(StrToInt(fall_field.Cells[0,0])-einheit);
         fall_field.Cells[1,0]:=IntToStr(StrToInt(fall_field.Cells[1,0]));
         fall_field.Cells[0,1]:=IntToStr(StrToInt(fall_field.Cells[0,1]));
         fall_field.Cells[1,1]:=IntToStr(StrToInt(fall_field.Cells[1,1])+einheit);
         fall_field.Cells[0,2]:=IntToStr(StrToInt(fall_field.Cells[0,2])+einheit);
         fall_field.Cells[1,2]:=IntToStr(StrToInt(fall_field.Cells[1,2]));
         fall_field.Cells[0,3]:=IntToStr(StrToInt(fall_field.Cells[0,3])+2*einheit);
         fall_field.Cells[1,3]:=IntToStr(StrToInt(fall_field.Cells[1,3])-einheit);
         fall_type.Text:='53';
        end;
    53: begin
         if CheckNewPosition(0,0,1) <> true then exit;
         if CheckNewPosition(1,1,0) <> true then exit;
         if CheckNewPosition(2,0,-1) <> true then exit;
         if CheckNewPosition(3,-1,-2) <> true then exit;
         fall_field.Cells[0,0]:=IntToStr(StrToInt(fall_field.Cells[0,0]));
         fall_field.Cells[1,0]:=IntToStr(StrToInt(fall_field.Cells[1,0])+einheit);
         fall_field.Cells[0,1]:=IntToStr(StrToInt(fall_field.Cells[0,1])+einheit);
         fall_field.Cells[1,1]:=IntToStr(StrToInt(fall_field.Cells[1,1]));
         fall_field.Cells[0,2]:=IntToStr(StrToInt(fall_field.Cells[0,2]));
         fall_field.Cells[1,2]:=IntToStr(StrToInt(fall_field.Cells[1,2])-einheit);
         fall_field.Cells[0,3]:=IntToStr(StrToInt(fall_field.Cells[0,3])-einheit);
         fall_field.Cells[1,3]:=IntToStr(StrToInt(fall_field.Cells[1,3])-2*einheit);
         fall_type.Text:='5';
       end;
    else
      begin end;
  end;
end;

procedure TForm1.E_PtsChange(Sender: TObject);
begin
if StrToInt(E_pts.Text)=10 then begin E_lvl.Text:='1'; Timer1.Interval:=Timer1.Interval-100; end;
if StrToInt(E_pts.Text)=20 then begin E_lvl.Text:='2'; Timer1.Interval:=Timer1.Interval-100; end;
if StrToInt(E_pts.Text)=30 then begin E_lvl.Text:='3'; Timer1.Interval:=Timer1.Interval-100; end;
if StrToInt(E_pts.Text)=40 then begin E_lvl.Text:='4'; Timer1.Interval:=Timer1.Interval-100; end;
if StrToInt(E_pts.Text)=50 then begin E_lvl.Text:='5'; Timer1.Interval:=Timer1.Interval-100; end;
if StrToInt(E_pts.Text)=60 then begin E_lvl.Text:='6'; Timer1.Interval:=Timer1.Interval-100; end;
if StrToInt(E_pts.Text)=70 then begin E_lvl.Text:='7'; Timer1.Interval:=Timer1.Interval-100; end;
if StrToInt(E_pts.Text)=80 then begin E_lvl.Text:='8'; Timer1.Interval:=Timer1.Interval-100; end;
if StrToInt(E_pts.Text)=90 then begin E_lvl.Text:='9'; Timer1.Interval:=Timer1.Interval-100; end;
if StrToInt(E_pts.Text)=100 then begin E_lvl.Text:='100'; Timer1.Interval:=Timer1.Interval-100; end;
end;

procedure TForm1.BTClick(Sender: TObject);
begin
  E_pts.Text:=IntToStr(StrToInt(E_pts.Text)+1);
end;

procedure TForm1.next_typeChange(Sender: TObject);
var z,e:Integer;
begin

  nextimage.Canvas.Brush.Color:=clWhite;
  nextimage.Canvas.Rectangle(0,0,Image1.Width,Image1.Height);
  nextimage.Canvas.Brush.Color:=clBlack;

  Val(next_type.Text,z,e);

  case z of
    0: begin
         nextimage.Canvas.Rectangle(einheit,0,2*einheit,einheit);
         nextimage.Canvas.Rectangle(2*einheit,0,3*einheit,einheit);
         nextimage.Canvas.Rectangle(einheit,einheit,2*einheit,2*einheit);
         nextimage.Canvas.Rectangle(2*einheit,einheit,3*einheit,2*einheit);
       end;
    1: begin
         nextimage.Canvas.Rectangle(0,einheit,einheit,2*einheit);
         nextimage.Canvas.Rectangle(1*einheit,einheit,2*einheit,2*einheit);
         nextimage.Canvas.Rectangle(1*einheit,0,2*einheit,einheit);
         nextimage.Canvas.Rectangle(2*einheit,0,3*einheit,einheit);
       end;
    2: begin
         nextimage.Canvas.Rectangle(0,0,einheit,einheit);
         nextimage.Canvas.Rectangle(einheit,0,2*einheit,einheit);
         nextimage.Canvas.Rectangle(einheit,einheit,2*einheit,2*einheit);
         nextimage.Canvas.Rectangle(2*einheit,einheit,3*einheit,2*einheit);
       end;
    3: begin
         nextimage.Canvas.Rectangle(0,0,einheit,einheit);
         nextimage.Canvas.Rectangle(einheit,0,2*einheit,einheit);
         nextimage.Canvas.Rectangle(2*einheit,0,3*einheit,einheit);
         nextimage.Canvas.Rectangle(3*einheit,0,4*einheit,einheit);
       end;
    4: begin
         nextimage.Canvas.Rectangle(einheit,0,2*einheit,einheit);
         nextimage.Canvas.Rectangle(einheit,einheit,2*einheit,2*einheit);
         nextimage.Canvas.Rectangle(einheit,2*einheit,2*einheit,3*einheit);
         nextimage.Canvas.Rectangle(2*einheit,2*einheit,3*einheit,3*einheit);
       end;
    5: begin
         nextimage.Canvas.Rectangle(einheit,2*einheit,2*einheit,3*einheit);
         nextimage.Canvas.Rectangle(2*einheit,2*einheit,3*einheit,3*einheit);
         nextimage.Canvas.Rectangle(2*einheit,einheit,3*einheit,2*einheit);
         nextimage.Canvas.Rectangle(2*einheit,0,3*einheit,einheit);
       end;
  end;

end;

end.
